//+------------------------------------------------------------------+
//|                                              MultiStrategyV3.mq5 |
//|                                        Copyright  2010, Farshad |
//|                                           http://www.vizhish.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Farshad Saremifar"
#property link      "farshad.saremifar@gmail.com"

#include <Trade/Trade.mqh>

#include <Trade\DealInfo.mqh>

#include <InitMQL4.mqh>


#include <Trade\DealInfo.mqh>


/*
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
*/
//+------------------------------------------------------------------+
//|                                                     Combo EA.mq4 |
//|                                        Copyright  2010, Farshad |
//|                                           http://www.vizhish.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Farshad Saremifar"
#property link      "farshad.saremifar@gmail.com"

input string Copyright="----------Copyright  2010, Farshad Saremifar----------";
input string Copyright2="----------Farshad.Saremifar@Gmail.com----------";
input string    Factor ="--------Combo Trader Factor---------";
input string    Factor2 ="--------Factor:1 to 3-------";
input int Combo_Trader_Factor=1;
input int USE_OPEN_PRICES=1;
input string StepMA_DESC="---------------Stepma-----------------------";
//---- input parameters
input int USE_3StepMA=1; 
input int USE_Last_3StepMA_Signal=1; 
input int USE_Last_3StepMA_Touch_Signal=0; 
input int StepMA_MODE=3; 
input int StepMA_TIMEFRAME=2;
input int TimeFrame=0;
input int     Length      = 10;    // Volty Length
input double  Kv          =  1.0;    // Sensivity Factor
input int     MA_Mode     =  0;    // Volty MA Mode : 0-SMA, 1-LWMA 
input int     StepSizeMIN =  23;    // Minimum Step Size  (if need)
input int     StepSizeMAX =  35;    // Maximum Step Size  (if need)
input int     ShiftMIN    =  0; 
input int     ShiftMID    =  0;
input int     ShiftMAX    =  0;
//-----------------------------------------
input string    ZigZag ="--------ZigZag Options---------";
input int       USE_ZZAG=0;
input int       USE_LAST_ZZAG_SIGNAL=0;
input int       ZZAG_TIMEFRAME=1; 
input int       ZZbar=3;

input int KeelOver=55;
input int Slalom=17;  

enum MAIN_SIGNAL_MODE{ MODE_MAIN,         MODE_SIGNAL };

input string    MA_Cross2 ="--------Moving Average Cross---------";
input string    MA_Cross3 ="--------Ma Mode:1 to 5-------";
input int    USE_MA = 0;//option 4
input int    USE_Last_MA_Signal = 0;
input int    MA_MODE = 5;//option 4
input ENUM_TIMEFRAMES    MA_TIMEFRAME = PERIOD_M15;//1,2,3,4,5,6
input int    FastMa_Period=5;                             
input int    MidMa_Period=13;
input int    SlowMa_Period=38;                             

input string MA_Cross4 =  "-------(SMA=0,EMA=1,SMMA=2,LWMA=3)------";                           
input int    FastMa_Method=1;                              //  (SMA=0,EMA=1,SMMA=2,LWMA=3)
input int    MidMa_Method=1;  
input int    SlowMa_Method=1;                              //  (SMA=0,EMA=1,SMMA=2,LWMA=3)
input string MA_Price =  "-----(PRICE_CLOSE=1,PRICE_OPEN=1,PRICE_HIGH=2,PRICE_LOW=3)-----";   
input string MA_Price2 = "-----(PRICE_MEDIAN=4,PRICE_TYPICAL=5,PRICE_WEIGHTED=6)----";   
input ENUM_APPLIED_PRICE    FastMa_Price= PRICE_CLOSE;                         
input ENUM_APPLIED_PRICE    MidMa_Price=PRICE_CLOSE;  
input ENUM_APPLIED_PRICE    SlowMa_Price=PRICE_CLOSE;                             
input ENUM_APPLIED_PRICE    FastMa_Shift=PRICE_CLOSE;                         
input ENUM_APPLIED_PRICE    MidMa_Shift=PRICE_CLOSE;   
input ENUM_APPLIED_PRICE    SlowMa_Shift=PRICE_CLOSE;    
input ENUM_APPLIED_PRICE    FastMa_Shifting=PRICE_CLOSE;                         
input ENUM_APPLIED_PRICE    MidMa_Shifting=PRICE_CLOSE;   
input ENUM_APPLIED_PRICE    SlowMa_Shifting=PRICE_CLOSE;      
  
input string RSI_DES = "-------------RSI-------------";
input int   USE_RSI=0;//option 1
input int   USE_Last_RSI_Signal = 0;
input ENUM_TIMEFRAMES    RSI_TIMEFRAME = PERIOD_M15;//1,2,3,4,5,6

input int    RSIperiod=14;
input int    RSIShift=0;
input string    RSI_DES2 = "----------Select RSI MODE :1-4";
input string    RSI_DES3 = "1 FOR OVERBOGHT/OVERSOLD -2 FOR RSI TREND 3-BOTH 1&2 4-FOR RSI AT THE ZONE";
input int    RSI_MODE = 1;
input string    RSI_DES4 = "-------This is for Overbought/Oversold zone";
input string    RSI_DES5 = "-------For RSI MODE 1 & 3";
input int    RSIHigh_Level         = 88;
input int    RSILow_Level          = 12;     

input string RSI_DES6 = "-------zone for buy and sell";
input string    RSI_DES7 = "-------For RSI MODE 4";
input int    RSIBuyZone          = 55;     
input int    RSISellZone         = 45;

input string    MACD_1 = "--------------MACD----------------";
input string    MACD_2 = "-----MACD signal , mode: 1=trend,2=Buy/sell at sell/buy zone,3=use both 1&2 ";
input int    USE_MACD = 0;//option 5
input int   USE_Last_MACD_Signal = 1;
input ENUM_TIMEFRAMES    MACD_TIMEFRAME = PERIOD_M15;//1,2,3,4,5,6

input int     MACD_MODE = 2;
input int     MACD_Fast = 12;
input int     MACD_Slow = 24;
input int     Signal_Period = 9;
input ENUM_APPLIED_PRICE     MACD_Price = PRICE_CLOSE;              // PRICE_CLOSE
input int     MACD_Shift = 0;
input string    MACD_3 = "--------------Choose MACD Indicator----------------";
input int    Zerolag_MACD =1;
input int    Classic_MACD =0;



input string    STO1_DES = "------- Stochastic--------";
input int      USE_STO = 1;//option 2
input int   USE_Last_STO_Signal = 0;
input ENUM_TIMEFRAMES    STO_TIMEFRAME =PERIOD_M15;//1,2,3,4,5,6

input int       STOK=5;
input int       STOD=3;
input int       STOL=3;
input string    STO3_DES = "-----Stochastic Overbough/OverSold Zone--";
input int      useSTOHighLow =1;
input int       STOHigh=80;
input int       STOLow=20;
input string    SAR_DES = "--------Parabolic SARS------------";
input int      USE_SAR = 0;//option 3
input int   USE_Last_SAR_Signal = 0;
input ENUM_TIMEFRAMES    SAR_TIMEFRAME = PERIOD_M15;//1,2,3,4,5,6

input double    SARStep = 0.02;
input double    SARMax = 0.2;
input int   Open_at_newbar=1;
input string    Desc = "-----END OF Opening MODES------";

input string  _Money_management    = "--------Money Management-------";
input bool   Use_Static_Lot=true;
input double Static_Lot=0.1;
input double Risk=5;
input string  _Position_Control    = "--------Position Control-------";
input int    useTrailingStop = 1;
input int    TrailingStop = 20;
input int Static_TP=30; 
input int Static_SL=30; 
input int Auto_Sl=1;

input int Max_orders=4;
input int Max_same_orders=2;


input string  _Trend_Control    = "-----------Select trend detecting values----------";
input int Trenddetect = 0;
input string  _Trend_Control2    = "1 for ADX,2 for Stepma";
input int Trend_Mode = 0;
input int Filtering_Noise = 0; 
input ENUM_TIMEFRAMES    NOISE_TIMEFRAME = PERIOD_M5;//1,2,3,4,5,6
 
input int ADX_PERIOD = 14;
input int ADX_MAINLEVEL = 20;
input string  _ADX_TIMEFRAME    = "---Use This To Check Trend On Any Time Frame";
input string  _ADX_TIMEFRAME2    = "1,2,3,4,5,6,7";
input ENUM_TIMEFRAMES ADX_TIMEFRAME=PERIOD_H4;
input string  _BOLLINGER_BAND    = "-----Use Bollinger Bands To Trade On Range Markets--------";
input int Use_BBand=0;
input ENUM_TIMEFRAMES    BBAND_TIMEFRAME = PERIOD_M15;//1,2,3,4,5,6
input int BB1_Period = 20;
input int BB2_Period = 20;
input int BB3_Period = 20;
input int Range_Parameter = 6;

input string  _Close_Modes    = "-------------Closing Modes-----------";
input string  _Close_Modes2   = "--------Choose How to Close a Position-----";
input int      AutoClose =0;
input int      USE_MA_CLOSING =0;
input int      MA_MODE_CLOSING=1;
input ENUM_TIMEFRAMES    MA_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int      USE_MACD_CLOSING =0;
input int      MACD_MODE_CLOSING=3;
input ENUM_TIMEFRAMES    MACD_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int      USE_RSI_CLOSING =0;
input int      RSI_MODE_CLOSING=3;
input ENUM_TIMEFRAMES    RSI_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int      USE_STO_CLOSING =0;
input ENUM_TIMEFRAMES    STO_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int      USE_SAR_CLOSING=0;
input ENUM_TIMEFRAMES    SAR_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int      USE_NOISE_CLOSING=0;
input ENUM_TIMEFRAMES    NOISE_TIMEFRAME_CLOSING = PERIOD_M15;//1,2,3,4,5,6
input int   NOISE_LOSS=90;
input int USE_ZZAG_CLOSING=1;
input int       ZZAG_Closebar=0;
input ENUM_TIMEFRAMES ZZAG_TIMEFRAME_CLOSING=PERIOD_M1;


input int      Open_opposite_after_close =0;
input string EXT="----------Extras--- Protecting Positions---";
input int UseTimeFilter=0;
input int StopTrade = 18;
input int StartTrade = 19;
input int Protect_Profit=0;
input double Profit_to_Close=40;
input int Loss_Contorl=0;
input double Loss_to_Close=40;
input int Cancel_Trading_On_Profit=0;
input int Cancel_Trading_On_Loss=0;
input bool  Send_Mail=false;
input int       MagicNumber = 1080; // Magic Number  
input string MARTINGALE="----------Martingale Section---------------";
input string MARTINGALE2="------I use different magic number&MM&TP& for martingale Positions------";
input int USE_MARTINGALE =0;
input int    Magic              = 772188;
input double TakeProfit         = 45;
input double Lots               = 0.01;
input double InitialStop        = 300;
input int    MaxTrades          = 10;
input double Multiplier         = 2;
input int    Pips               = 30;
input int    OrderstoProtect    = 6;
input int   Money_management   = 0;
input string MARTINGALE3="0: Standard account(NorthFinance,MiG,Alpari) 1: Normal account(FXLQ,FXDD) 2:InterbankFX\'s NANO Account";
input int    AccountType        = 2;        //0: Standard account(NorthFinance,MiG,Alpari) 1: Normal account(FXLQ,FXDD) 2:InterbankFX's NANO Account
input double risk               = 0.5;
input int   ReverseSignal      = 0; 



bool   MarketWatch=false;
bool   gbDisabled    = false; 

double fasterStepnow, fasterStepprevious, fasterStepafter;
   double mediumStepnow, mediumStepprevious, mediumStepafter;
   double slowerStepnow, slowerStepprevious, slowerStepafter;
   
datetime TimeStamp=0;
int  OpenOrders=0, cnt=0;
int  slippage=5;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int mode=0, myOrderType=0;
bool ContinueOpening=true;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastClosePrice=0, LastLots=0;
double PipValue=0;

double  LOT;
int options[];
double SLBUY,TPBUY,SLSELL,TPSELL,lotb,lots;
bool cantrade=true;    
 int Periodo = 7;
int Signal = 6 ;
double Buffer=3.8;
 int Shift1=1;
int Shift2=6;
double Buy_StopLoss ,Sell_StopLoss,Buy_TakeProfit,Sell_TakeProfit, SL_Sell,SL_Buy;                       

int New_Bar;                                             
int Time_0;                                              
int PosOpen;                                          
int PosClose;                                           
int total;                                             
double FastMaCurrent,MidMaCurrent,FastMaPrevious,MidMaPrevious,SlowMaCurrent,SlowMaPrevious,MA1CrossBuffer,MA2CrossBuffer;                                          
                                        
double zzagbuy,zzagsell,zzagclose;                                    
double MACD_Main_0;
double MACD_Main_1;
double MACD_Signal_0;
double MACD_Signal_1;                 
double macdMain;
double macdSignal;
double macdMainPrev ;
double macdSignalPrev;                           
double RSIValue,RSIcurrent,RSIprevious;
double SARSignal;
double STOValue = 0;
double STOSignal = 0;
double STOValuepre = 0;
double STOSignalpre = 0;
int countoption,notused,uptrend,downtrend,o = 0; //1 = buy, 2 = sell
int MA,MACD,RSI,STO,SAR,MACD2,RSI2;   


int signals[];
int MyPoint;   
bool canbuy,cansell,trenddetect;



//CLOSING VARIABLES
double CFastMaCurrent,CMidMaCurrent,CFastMaPrevious,CMidMaPrevious,CSlowMaCurrent,CSlowMaPrevious,CMA1CrossBuffer,CMA2CrossBuffer;                                          
                                          
double value1;
double value2;
double value3;                                
double CMACD_Main_0;
double CMACD_Main_1;
double CMACD_Signal_0;
double CMACD_Signal_1;                 
double CmacdMain;
double CmacdSignal;
double CmacdMainPrev ;
double CmacdSignalPrev;                           
double CRSIValue,CRSIcurrent,CRSIprevious;
double CSARSignal,upperenv,lowerenv;
double CSTOValue = 0;
double CSTOSignal = 0;
double CSTOValuepre = 0;
double CSTOSignalpre = 0;
static datetime LastTradeBarTime;
static int last_ma_signal,last_macd_signal,last_sto_signal,last_sar_signal,last_rsi_signal;
static int last_ma2_signal,last_macd2_signal,last_rsi2_signal;
static int last_ma3_signal,last_macd3_signal,last_rsi3_signal;
static int last_ma4_signal,last_macd4_signal,last_rsi4_signal;
static int last_ma5_signal,last_zzag1_signal,last_step_signal,last_step_touch_signal;



//============================================================================================
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----
  
if(Digits()==3||Digits()==5)MyPoint=10; else MyPoint=1;
//----



datetime Time[];
int count;   // number of elements to copy
ArraySetAsSeries(Time,true);
CopyTime(_Symbol,_Period,0,count,Time);

LastTradeBarTime = Time[1]; // initialise the variable


last_ma_signal=0;last_macd_signal=0;last_sto_signal=0;last_sar_signal=0;last_rsi_signal=0;
last_ma2_signal=0;last_macd2_signal=0;last_rsi2_signal=0;
last_ma3_signal=0;last_macd3_signal=0;last_rsi3_signal=0;
last_ma4_signal=0;last_macd4_signal=0;last_rsi4_signal=0;
last_ma5_signal=0;
last_zzag1_signal=0;
last_step_signal=0;
last_step_touch_signal=0;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int OnDeinit()
  {
//----
  //ObjectsDeleteAll(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


//============================================================================================
int OnTick()  
 {
 //check for new bar===========================================================   
   New_Bar=0;                                           
   
   datetime Time[];
int count;   // number of elements to copy
ArraySetAsSeries(Time,true);
CopyTime(_Symbol,_Period,0,count,Time);
   
   if (Time_0 != Time[0])                                  
      {
      New_Bar= 1;      
      //calculate (); 
                                             
      Time_0 = Time[0]; 
      }
        // ------
 canbuy=false;cansell=false;   
if (checkmaxorders()<1){
  if (UseTimeFilter==1)
     {//check trading time
        if (HourMQL4()>StopTrade && HourMQL4()<StartTrade) 
        {return(0);}//End of trading time check
     }
 }

   if (useTrailingStop==1){Trail(TrailingStop);}                                    

 




    
 
   // ------

  
 if(USE_OPEN_PRICES==1){if(New_Bar==1) {calculate();StartTrade();}}
 else {calculate();StartTrade();}
 


 
  display();      



 

  


//================================
//----


  
   
 
 return(0);
}  

//**********************************END OF START ********************************

void StartTrade()
{
if (Protect_Profit==1)Save_Profit();
 if (Loss_Contorl==1)Save_Loss();
if (Cancel_Trading_On_Profit==1||Cancel_Trading_On_Loss==1)checkcanTrading();
   

 if(Trenddetect==1) trenddetect=trend_detect();
    if (AutoClose==1)autoclosing();
if (Trenddetect==1||Use_BBand==1){
 if (Combo_Trader_Factor==1)
{
 if (Trenddetect==1&&Use_BBand==1)
   {
       if (trenddetect==3||trenddetect==4)
            {
                if (bband()==1){canbuy=true;cansell=false;}
                  if (bband()==2){canbuy=false;cansell=true;}
  
                  if (Filtering_Noise&&signalTRIX()==1){canbuy=false;cansell=false;}
             }
      else {
  
  
             if (trenddetect==1&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
             if (trenddetect==2&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      
  
  
          }
  }
   if (Trenddetect==0&&Use_BBand==0)
  {
  if (Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  if (Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
   
  
  
  }
 if (Trenddetect==0&&Use_BBand==1)
   {
      if (bband()==1||Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else if (bband()==2||Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else {canbuy=false;cansell=false;if (Filtering_Noise&&signalTRIX()==1){canbuy=false;cansell=false;}}
   }
   
   if (Trenddetect==1&&Use_BBand==0)
  {
   if (trenddetect==1&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
   if (trenddetect==2&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
       
  
  
  } 
   
 }//-------------------------COmbo Trader Factor 1
 
else if (Combo_Trader_Factor==2)
 {
 if (Trenddetect==1&&Use_BBand==0)
 {
      if (trenddetect==1&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      if (trenddetect==2&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      if (trenddetect==3&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      if (trenddetect==4&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  
  } 

       
else if (Trenddetect==1&&Use_BBand==1)
{
if (trenddetect==1&&Signal()==1&&bband()!=1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
else if (trenddetect==2&&Signal()==2&&bband()!=2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
else if (trenddetect==3&&Signal()==2&&bband()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
else if (trenddetect==4&&Signal()==1&&bband()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
   


}
 else if (Trenddetect==0&&Use_BBand==0)
 {
  if (Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  if (Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}

 }
  else if (Trenddetect==0&&Use_BBand==1)
   {
      if (bband()==1&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else if (bband()==2&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else {canbuy=false;cansell=false;if (Filtering_Noise&&signalTRIX()==1){canbuy=false;cansell=false;}}
   }
}   
//---------------------------------Combo Trader Factor 2
 else if (Combo_Trader_Factor==3)
 {
       if (Trenddetect==1&&Use_BBand==1)
            {
            
            if (trenddetect==1&&Signal()==1&&bband()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
            else if (trenddetect==2&&Signal()==2&&bband()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
            else if (trenddetect==3&&Signal()==2&&bband()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
            else if (trenddetect==4&&Signal()==1&&bband()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
            
            }
         
         else if (Trenddetect==0&&Use_BBand==0)
         {
             if (Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
              if (Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
            }
         else if (Trenddetect==1&&Use_BBand==0)
            {
                  if (trenddetect==1&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
                  if (trenddetect==2&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
                  if (trenddetect==3&&Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
                  if (trenddetect==4&&Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  
             }      
    else if (Trenddetect==0&&Use_BBand==1)
            {
      if (bband()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else if (bband()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
      else {canbuy=false;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
         }      
 
  

 }  
 
}

else{  if (Signal()==1){canbuy=true;cansell=false;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  if (Signal()==2){canbuy=false;cansell=true;if (Filtering_Noise==1&&signalTRIX()==1){canbuy=false;cansell=false;}}
  }
 




bool cantradings=false;
if (checkmaxorders()<Max_orders)
 {
  if (Open_at_newbar==1&&New_Bar==1)cantradings=true;
  if (Open_at_newbar==1&&New_Bar==0)cantradings=false;
  if (Open_at_newbar==0)cantradings=true;
  
 if (checkbuyorders()<Max_same_orders&&canbuy&&cantradings)
      {   
 
                    LOT = LOT(Risk,OrdersTotal()+1);
                      OPENORDER ("Buy"); 
                   
      }     
   
   
    else if (checksellorders()<Max_same_orders&&cansell&&cantradings)
     
      {

         
                    LOT = LOT(Risk,OrdersTotal()+1);
          OPENORDER ("Sell");
          
      }     

} 

if (USE_MARTINGALE==1) Martingale();
}

//============================================================================================
void autoclosing()
{
if(CloseSignal()==1) CLOSEORDER("Sell");
if(CloseSignal()==2) CLOSEORDER("Buy");
if (USE_ZZAG_CLOSING&&CZZAG()!=0)
{
CLOSEORDER("All");



}
}
void CLOSEORDER(string ord)
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
     // if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
     if(OrderGetTicket(i)==true)
      {

MqlTick last_tick;
SymbolInfoTick(_Symbol,last_tick);
double Bid=last_tick.bid;
double Ask=last_tick.ask;

   MqlTradeRequest mrequest;                             // Will be used for trade requests
   MqlTradeResult mresult;                               // Will be used for results of trade requests
   double AskTR = SymbolInfoDouble(_Symbol,SYMBOL_ASK);    // Ask price
   double BidTR = SymbolInfoDouble(_Symbol,SYMBOL_BID);    // Bid price
      
         //if (SYMBOL_CURRENCY_BASE!=Symbol()||OrderMagicNumber()!= MagicNumber) continue;
         if (SymbolInfoString(_Symbol) !=Symbol()||OrderMagicNumber()!= MagicNumber) continue;
         
         
         if (OrderType()==OP_BUY && ord=="Buy")
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);// Close Buy
         if (OrderType()==OP_SELL && ord=="Sell")
            OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);// Close Sell
         if (OrderType()==OP_SELL && ord=="All")
             OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);// Close Sell
         if (OrderType()==OP_BUY && ord=="All")
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);// Close Buy  
      }   
   }
}
int checkmaxorders()
{
int maxtrades=0;

   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;
         else if (OrderMagicNumber() == MagicNumber){maxtrades=maxtrades+1;}
      }   
   }
 return(maxtrades);  
}
//========================================================================================
int checkbuyorders()
{
int buytrades=0;

   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;
         else if(OrderMagicNumber() == MagicNumber && OrderType()==OP_BUY){buytrades=buytrades+1;}
      }   
   }
 return(buytrades);  
}

//====================================================================================================
int checksellorders()
{
int selltrades=0;

   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;
         else if(OrderMagicNumber() == MagicNumber && OrderType()==OP_SELL){selltrades=selltrades+1;}
      }   
   }
 return(selltrades);  
}
//=================================================================================================
void Trail(int TrailingStop0)
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
          MqlTick last_tick;
SymbolInfoTick(_Symbol,last_tick);
double Bid=last_tick.bid;

SymbolInfoTick(_Symbol,last_tick);
double Ask=last_tick.ask;
    
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
            if (OrderType() == OP_BUY && Bid - OrderOpenPrice() > NormalizeDouble(TrailingStop0*Point()*MyPoint,Digits()))
            {
                if (OrderStopLoss() < NormalizeDouble(Bid-(TrailingStop0+3)*Point()*MyPoint,Digits()))
                    OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Bid-TrailingStop0*Point()*MyPoint,Digits()),NormalizeDouble( Bid+( TrailingStop0)*Point()*MyPoint,Digits()), OrderExpiration(), White);
               
              
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Ask > NormalizeDouble(TrailingStop0*Point()*MyPoint,Digits()))
            {
                   
                if (OrderStopLoss() > NormalizeDouble(Ask+(TrailingStop0+3)*Point()*MyPoint,Digits()))

                    OrderModify(OrderTicket(), OrderOpenPrice(),NormalizeDouble( Ask+TrailingStop0*Point()*MyPoint,Digits()), NormalizeDouble(Ask-(TrailingStop0)*Point()*MyPoint,Digits()), OrderExpiration(), White);
            }
                                               
            
        }
    }
 
}

//===============================================================================================================

//============================================================================================
int MAMethod(int MA_Method)
   {
      switch(MA_Method)
        {
         case 0: return(0);                                   // MODE_SMA=0
         case 1: return(1);                                   // MODE_EMA=1
         case 2: return(2);                                   // MODE_SMMA=2
         case 3: return(3);                                  // MODE_LWMA=3
        }
   }
//============================================================================================
int MAPrice(int MA_Price)
   {
      switch(MA_Price)
        {
         case 0: return(PRICE_CLOSE);                        // PRICE_CLOSE=0        
         case 1: return(PRICE_OPEN);                         //PRICE_OPEN=1
         case 2: return(PRICE_HIGH);                         // PRICE_HIGH=2
         case 3: return(PRICE_LOW);                           // PRICE_LOW=3
         case 4: return(PRICE_MEDIAN);                        // PRICE_MEDIAN=4
         case 5: return(PRICE_TYPICAL);                       // PRICE_TYPICAL=5
         case 6: return(PRICE_WEIGHTED);                      // PRICE_WEIGHTED=6
        }
   }
   
//=============================================================================================   
/*void ShowERROR(int Ticket,double SL,double TP)
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:                                                                               return;
      case 2:   Alert("Error Connection with trade server absent    ",Ticket," ",Symbol());return;
      case 3:   Alert("Error Invalid trade parameters   Ticket ",  Ticket," ",Symbol());return;
      case 130: Alert("Error Invalid stops   Ticket ",             Ticket," ",Symbol());return;
      case 134: Alert("Error Not enough money   ",                 Ticket," ",Symbol());return;
      case 146: Alert("Error Trade context is busy. ",             Ticket," ",Symbol());return;
      case 129: Alert("Error Invalid price ",                      Ticket," ",Symbol());return;
      case 131: Alert("Error Invalid volume ",                     Ticket," ",Symbol());return;
      case 4051:Alert("Error Invalid function parameter value ", Ticket," ",Symbol());return;
      case 4105:Alert("Error No order selected ",                Ticket," ",Symbol());return;
      case 4063:Alert("Error Integer parameter expected ",       Ticket," ",Symbol());return;
      case 4200:Alert("Error    ",            Ticket," ",Symbol());return;
      default:  Alert("Error Object already exists " ,err,"   Ticket ", Ticket," ",Symbol());return;
   }
}
*/
//===================================================================================================
double LOT(int risk,int ord)
{  if (Use_Static_Lot==true&&Static_Lot>=MarketInfo(Symbol(),MODE_MINLOT))LOT=Static_Lot;
  else if(Use_Static_Lot==false&& risk>0)  {

   double MINLOT = MarketInfo(Symbol(),MODE_MINLOT);
   LOT = AccountFreeMargin()*risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/ord;
   if (LOT>MarketInfo(Symbol(),MODE_MAXLOT)) LOT = MarketInfo(Symbol(),MODE_MAXLOT);
   if (LOT<MINLOT) LOT = MINLOT;
   if (MINLOT<0.1) LOT = NormalizeDouble(LOT,2); else LOT = NormalizeDouble(LOT,1);
   }
   else {Alert("Error You Have Choosed Wrong Lots ",Symbol());return;}
   return(LOT);
}
//===========================================================================================================

//========================================================================================================
void OPENORDER(string ord)
{
        int error;
  
  
   if (Auto_Sl==1)
  {
  double slowerStep     =iCustom(NULL,0,"StepMA_3D_v3m",Length,Kv,MA_Mode,StepSizeMIN*MyPoint,StepSizeMAX*MyPoint,ShiftMIN,ShiftMID,ShiftMAX,2,0);
  
  if (ord=="Buy" )Buy_StopLoss=NormalizeDouble(slowerStep-Static_SL*Point()*MyPoint,Digits());
   if (ord=="Sell")Sell_StopLoss=NormalizeDouble(slowerStep+Static_SL*Point()*MyPoint,Digits());
  
  } 

   else {
   
         MqlTick last_tick;
SymbolInfoTick(_Symbol,last_tick);
double Bid=last_tick.bid;

SymbolInfoTick(_Symbol,last_tick);
double Ask=last_tick.ask;

   if (ord=="Buy" )Buy_StopLoss=NormalizeDouble(Ask-Static_SL*Point()*MyPoint,Digits());
   if (ord=="Sell")Sell_StopLoss=NormalizeDouble(Bid+Static_SL*Point()*MyPoint,Digits());
   }
 
         MqlTick last_tick;
SymbolInfoTick(_Symbol,last_tick);
double Bid=last_tick.bid;

SymbolInfoTick(_Symbol,last_tick);
double Ask=last_tick.ask;
  
   if (ord=="Buy" )Buy_TakeProfit=NormalizeDouble(Ask+Static_TP*Point()*MyPoint,Digits());
   if (ord=="Sell")Sell_TakeProfit=NormalizeDouble(Bid-Static_TP*Point()*MyPoint,Digits());
   
   
   

 
  if (LastTradeBarTime == Time[0]) return(0);
  else {
 
  // if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUY,LOT,Ask,4,Buy_StopLoss,Buy_TakeProfit,"FSF Semi COMBO Trader "+Symbol()+Period(),MagicNumber, 0,Blue);
   //if (ord=="Sell") error=OrderSend(Symbol(),OP_SELL,LOT,Bid,4,Sell_StopLoss,Sell_TakeProfit,"FSF Semi COMBO Trader "+Symbol()+Period(),MagicNumber,0,Red);
   if (ord=="Buy" ) OpenPosition(Symbol(),OP_BUY, LOT,Buy_StopLoss,Buy_TakeProfit, MagicNumber,"FSF MultiStrategy"+Symbol()+Period());
   if (ord=="Sell" ) OpenPosition(Symbol(),OP_SELL, LOT,Sell_StopLoss,Sell_TakeProfit, MagicNumber,"FSF MultiStrategy"+Symbol()+Period());
   
   /*if (error==-1) //operation failed
   {  
      ShowERROR(error,0,0);
   }
    */
    LastTradeBarTime = Time[0]; 
    
    
   //if (error!=-1&&Send_Mail==true) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits()) + ord);   
   }
return;

}    
//===========================================================================================================
   
//Calculate==================================
void calculate ()
   {


if (Filtering_Noise==1||NOISE_TIMEFRAME_CLOSING==1){    
value1=iCustom(Symbol(),NOISE_TIMEFRAME,"Damiani_volatmeter",0,0);
value2=iCustom(Symbol(),NOISE_TIMEFRAME,"Damiani_volatmeter",1,0);
value3=iCustom(Symbol(),NOISE_TIMEFRAME,"Damiani_volatmeter",2,0);
}    
if(USE_MACD==1){    //MACD
   if (Zerolag_MACD==1&&!Classic_MACD==1) {
   MACD_Main_0 = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   MACD_Main_1 = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   MACD_Signal_0 = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   MACD_Signal_1 = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);
   macdMain = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   macdSignal = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   macdMainPrev = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   macdSignalPrev = iCustom(Symbol(),MACD_TIMEFRAME,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);  
  } 
  else if (!Zerolag_MACD&&Classic_MACD) { 
   MACD_Main_0 = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   MACD_Main_1 = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   MACD_Signal_0 = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   MACD_Signal_1 = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);
   macdMain = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   macdSignal = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   macdMainPrev = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   macdSignalPrev = iMACD(Symbol(),MACD_TIMEFRAME,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);  
  } 
  else Alert("You Have To choose Zerolag MACD Or Classic MACD");
} 
if(USE_MA==1){  
FastMaCurrent = iMA(NULL, MA_TIMEFRAME, FastMa_Period, FastMa_Shift,MAMethod( FastMa_Method), MAPrice(FastMa_Price),FastMa_Shifting);
MidMaCurrent = iMA(NULL, MA_TIMEFRAME, MidMa_Period, MidMa_Shift, MAMethod(MidMa_Method), MAPrice(MidMa_Price), MidMa_Shifting);
SlowMaCurrent = iMA(NULL, MA_TIMEFRAME, SlowMa_Period, SlowMa_Shift, MAMethod(SlowMa_Method), MAPrice(SlowMa_Price), SlowMa_Shifting);

FastMaPrevious = iMA(NULL, MA_TIMEFRAME, FastMa_Period, FastMa_Shift, MAMethod(FastMa_Method), MAPrice(FastMa_Price), FastMa_Shifting+1);
MidMaPrevious = iMA(NULL, MA_TIMEFRAME, MidMa_Period, MidMa_Shift, MAMethod(MidMa_Method), MAPrice(MidMa_Price),MidMa_Shifting+1);
SlowMaPrevious = iMA(NULL, MA_TIMEFRAME, SlowMa_Period, SlowMa_Shift, MAMethod(SlowMa_Method), MAPrice(SlowMa_Price),SlowMa_Shifting+1);

} 
   
if(USE_RSI==1){     //RSI
    RSIcurrent=iRSI(NULL,RSI_TIMEFRAME,RSIperiod,PRICE_CLOSE,RSIShift);
   RSIprevious=iRSI(NULL,RSI_TIMEFRAME,RSIperiod,PRICE_CLOSE,RSIShift+1);
  }
   
 if(USE_SAR==1){    //SAR
   SARSignal = iSAR(Symbol(),SAR_TIMEFRAME,SARStep,SARMax,0);
}
   
  if(USE_STO==1){   //STOCHASTIC
    STOValue = iStochastic(Symbol(),STO_TIMEFRAME,STOK,STOD,STOL,0,0,MODE_MAIN,0);
    STOSignal = iStochastic(Symbol(),STO_TIMEFRAME,STOK,STOD,STOL,0,0,MODE_SIGNAL,0);
    STOValuepre = iStochastic(Symbol(),STO_TIMEFRAME,STOK,STOD,STOL,0,0,MODE_MAIN,1);
    STOSignalpre = iStochastic(Symbol(),STO_TIMEFRAME,STOK,STOD,STOL,0,0,MODE_SIGNAL,1);
  }
  if (USE_ZZAG==1){
  zzagbuy=iCustom(Symbol(),ZZAG_TIMEFRAME,"ZigAndZag",KeelOver,Slalom,5,ZZbar);
  zzagsell=iCustom(Symbol(),ZZAG_TIMEFRAME,"ZigAndZag",KeelOver,Slalom,6,ZZbar);
  
  }  
 if (USE_3StepMA==1||Trenddetect==1)
  {
 // stepmaup=iCustom(NULL,StepMA_TIMEFRAME,"StepMa_Cross",TimeFrame,Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,true,false,false,false,false,false,1,0);
 // stepmadown=iCustom(NULL,StepMA_TIMEFRAME,"StepMa_Cross",TimeFrame,Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,true,false,false,false,false,false,0,0);
  mediumStepnow     =iCustom(NULL,0,"StepMA_3D_v3m",Length,Kv,MA_Mode,StepSizeMIN*MyPoint,StepSizeMAX*MyPoint,ShiftMIN,ShiftMID,ShiftMAX,1,0);
  mediumStepprevious=iCustom(NULL,0,"StepMA_3D_v3m",Length,Kv,MA_Mode,StepSizeMIN*MyPoint,StepSizeMAX*MyPoint,ShiftMIN,ShiftMID,ShiftMAX,1,1);
  slowerStepnow     =iCustom(NULL,0,"StepMA_3D_v3m",Length,Kv,MA_Mode,StepSizeMIN*MyPoint,StepSizeMAX*MyPoint,ShiftMIN,ShiftMID,ShiftMAX,2,0);
  slowerStepprevious=iCustom(NULL,0,"StepMA_3D_v3m",Length,Kv,MA_Mode,StepSizeMIN*MyPoint,StepSizeMAX*MyPoint,ShiftMIN,ShiftMID,ShiftMAX,2,1);
  //stepmatouchup=iCustom(NULL,StepMA_TIMEFRAME,"StepMa_Touching",TimeFrame,Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,true,false,false,false,false,false,2,0);
 // stepmatouchdown=iCustom(NULL,StepMA_TIMEFRAME,"StepMa_Touching",TimeFrame,Length,Kv,MA_Mode,StepSizeMIN,StepSizeMAX,ShiftMIN,ShiftMID,ShiftMAX,true,false,false,false,false,false,3,0);
  
  } 
 
if(USE_MACD_CLOSING==1){     
   //--------------------CLOSING VARIABLES---------------------------------------
   if (Zerolag_MACD==1&&!Classic_MACD==1) {
   CMACD_Main_0 = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   CMACD_Main_1 = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   CMACD_Signal_0 = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   CMACD_Signal_1 = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);
   CmacdMain = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   CmacdSignal = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   CmacdMainPrev = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   CmacdSignalPrev = iCustom(Symbol(),MACD_TIMEFRAME_CLOSING,"ZeroLag MACD",MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);  
  } 
  else if (!Zerolag_MACD==1&&Classic_MACD==1) {
   CMACD_Main_0 = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   CMACD_Main_1 = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   CMACD_Signal_0 = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   CMACD_Signal_1 = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);
   CmacdMain = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift);
   CmacdSignal = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift);
   CmacdMainPrev = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_MAIN,MACD_Shift+1);
   CmacdSignalPrev = iMACD(Symbol(),MACD_TIMEFRAME_CLOSING,MACD_Fast,MACD_Slow,Signal_Period,MACD_Price,MODE_SIGNAL,MACD_Shift+1);  
  } 
  else Alert("You Have To choose Zerolag MACD Or Classic MACD");
} 
if(USE_MA_CLOSING==1){     
CFastMaCurrent = iMA(NULL, MA_TIMEFRAME_CLOSING, FastMa_Period, FastMa_Shift,MAMethod( FastMa_Method), MAPrice(FastMa_Price),FastMa_Shifting);
CMidMaCurrent = iMA(NULL, MA_TIMEFRAME_CLOSING, MidMa_Period, MidMa_Shift, MAMethod(MidMa_Method), MAPrice(MidMa_Price), MidMa_Shifting);
CSlowMaCurrent = iMA(NULL, MA_TIMEFRAME_CLOSING, SlowMa_Period, SlowMa_Shift, MAMethod(SlowMa_Method), MAPrice(SlowMa_Price), SlowMa_Shifting);

CFastMaPrevious = iMA(NULL, MA_TIMEFRAME_CLOSING, FastMa_Period, FastMa_Shift, MAMethod(FastMa_Method), MAPrice(FastMa_Price), FastMa_Shifting+1);
CMidMaPrevious = iMA(NULL, MA_TIMEFRAME_CLOSING, MidMa_Period, MidMa_Shift, MAMethod(MidMa_Method), MAPrice(MidMa_Price),MidMa_Shifting+1);
CSlowMaPrevious = iMA(NULL, MA_TIMEFRAME_CLOSING, SlowMa_Period, SlowMa_Shift, MAMethod(SlowMa_Method), MAPrice(SlowMa_Price),SlowMa_Shifting+1);
}
 
   
 if(USE_RSI_CLOSING==1){       //RSI
   CRSIcurrent=iRSI(NULL,RSI_TIMEFRAME_CLOSING,RSIperiod,PRICE_CLOSE,0);
   CRSIprevious=iRSI(NULL,RSI_TIMEFRAME_CLOSING,RSIperiod,PRICE_CLOSE,1);
  }
   
  if(USE_SAR_CLOSING==1){      //SAR
   CSARSignal = iSAR(Symbol(),SAR_TIMEFRAME_CLOSING,SARStep,SARMax,0);

   }
 if(USE_STO_CLOSING==1){       //STOCHASTIC
    CSTOValue = iStochastic(Symbol(),STO_TIMEFRAME_CLOSING,STOK,STOD,STOL,0,0,MODE_MAIN,0);
   CSTOSignal = iStochastic(Symbol(),STO_TIMEFRAME_CLOSING,STOK,STOD,STOL,0,0,MODE_SIGNAL,0);
   CSTOValuepre = iStochastic(Symbol(),STO_TIMEFRAME_CLOSING,STOK,STOD,STOL,0,0,MODE_MAIN,1);
   CSTOSignalpre = iStochastic(Symbol(),STO_TIMEFRAME_CLOSING,STOK,STOD,STOL,0,0,MODE_SIGNAL,1);
  }
    
  
  if (USE_ZZAG_CLOSING==1){
  zzagclose=iCustom(NULL,ZZAG_TIMEFRAME_CLOSING,"ZigAndZag",KeelOver,Slalom,4,ZZAG_Closebar);
  
  
  }   
   
   
   
   
   }
   
  
   
//MA Cross======================================================================================
int MA()
   {
   int PosOpen=0; 
   double curr,prev;
   curr=FastMaCurrent - MidMaCurrent;
  prev=FastMaPrevious - MidMaPrevious;                                  
   if((curr*prev<=0)&&(curr>0)) 
              
      {
      
      PosOpen=1;
      }  
   if((curr*prev<=0)&&(curr<0)) 
                      
      {
      PosOpen=2;
      }             
    if (USE_Last_MA_Signal==1){
            
            
            if (last_ma_signal!=PosOpen&&PosOpen>0){last_ma_signal=PosOpen;return(last_ma_signal);}
            else return(last_ma_signal);
            }
     else return(PosOpen);                                         
   }   
   
//MA2 Cross======================================================================================
int MA2()
   {
   
   int PosOpen=0; 
    double curr,prev;
   curr=MidMaCurrent - SlowMaCurrent;
  prev=MidMaPrevious - SlowMaPrevious;      
   if((curr*prev<=0)&&(curr>0)) 
                                                   
      {
      PosOpen=1;
      } 
   if((curr*prev<=0)&&(curr<0)) 
                      
      {
      PosOpen=2;
      }             
     if (USE_Last_MA_Signal==1){
            
            
            if (last_ma2_signal!=PosOpen&&PosOpen>0){last_ma2_signal=PosOpen;return(last_ma2_signal);}
            else return(last_ma2_signal);
            }
  else return(PosOpen);                                          
   }   
   
//MA3 Cross======================================================================================
int MA3()
   {
   
   int PosOpen=0;                                                 
   if (MA2()==1||MA()==1)    //buy signal
      {
      PosOpen=1;
      }                  
   if (MA2()==2||MA()==2) // sell signall
      {
      PosOpen=2;
      }             
     if (USE_Last_MA_Signal==1){
            
            
            if (last_ma3_signal!=PosOpen&&PosOpen>0){last_ma3_signal=PosOpen;return(last_ma3_signal);}
             else return(last_ma3_signal);
            }
   else return(PosOpen);                                         
   }   
      
   
//MA4 Cross======================================================================================
int MA4()
   {
   
   int PosOpen=0; 
    double curr,prev;
   curr=FastMaCurrent - SlowMaCurrent;
  prev=FastMaPrevious - SlowMaPrevious;   
   if((curr*prev<=0)&&(curr>0)) 
                                                   
      {
      PosOpen=1;
      } 
   if((curr*prev<=0)&&(curr<0)) 
                      
       {
      PosOpen=2;
      }             
     if (USE_Last_MA_Signal==1){
            
            
            if (last_ma4_signal!=PosOpen&&PosOpen>0){last_ma4_signal=PosOpen;return(last_ma4_signal);}
             else return(last_ma4_signal);
            }
   else return(PosOpen);                                         
   }   
//MA5 Cross======================================================================================
int MA5()
   {
   
   int PosOpen=0;                                                 
   if (MA3()==1||MA4()==1)    //buy signal
      {
      PosOpen=1;
      }                  
   if (MA3()==2||MA4()==2) // sell signall
      {
      PosOpen=2;
      }             
    if (USE_Last_MA_Signal==1){
           
            
            if (last_ma5_signal!=PosOpen&&PosOpen>0){last_ma5_signal=PosOpen;return(last_ma5_signal);}
             else return(last_ma5_signal);
            } 
   else return(PosOpen);                                         
   }   
      
   





//============================================================================================
//MACD TREND METHOD============================================================
int MACD()
   {
  int MACDTrend=0;
   
   
   
   if(MACD_Main_0>MACD_Main_1 && MACD_Signal_0>MACD_Signal_1 && MACD_Main_0>MACD_Signal_0) {MACDTrend = 1;}    //buy
   if(MACD_Main_0<MACD_Main_1 && MACD_Signal_0<MACD_Signal_1 && MACD_Main_0<MACD_Signal_0) {MACDTrend = 2;}    // sell
   if(MACD_Main_0<MACD_Main_1 && MACD_Signal_0>MACD_Signal_1 && MACD_Main_0>MACD_Signal_0) {MACDTrend = 3;}    // up-down
   if(MACD_Main_0>MACD_Main_1 && MACD_Signal_0<MACD_Signal_1 && MACD_Main_0<MACD_Signal_0) {MACDTrend = 4;}    // down-up
    if (USE_Last_MACD_Signal==1){
           
            
            if (last_macd_signal!=MACDTrend&&MACDTrend>0){last_macd_signal=MACDTrend;return(last_macd_signal);}
             else return(last_macd_signal);
            }
  else return(MACDTrend);
   }
//==MACD MODE 2=============================================================
int MACD2()
   {
   int MACDTrend = 0;   //1=Buy , 2= Sell


   if(macdMain>macdSignal && macdMainPrev<=macdSignalPrev && macdMain<0 && macdMainPrev<0){MACDTrend = 1;}
   else if(macdMain<macdSignal && macdMainPrev>=macdSignalPrev && macdMain>0 && macdMainPrev>0){MACDTrend = 2;}
   
     if (USE_Last_MACD_Signal==1){
            
            
            if (last_macd2_signal!=MACDTrend&&MACDTrend>0){last_macd2_signal=MACDTrend;return(last_macd2_signal);}
            else return(last_macd2_signal);
            }
   else return(MACDTrend);

      
   }   
//==MACD Both=============================================================
int MACD3()
   {
   int MACDTrend = 0;   //1=Buy , 2= Sell


   if((macdMain>macdSignal && macdMainPrev<=macdSignalPrev && macdMain<0 && macdMainPrev<0)
   ||(MACD_Main_0>MACD_Main_1 && MACD_Signal_0>MACD_Signal_1 && MACD_Main_0>MACD_Signal_0))
   {MACDTrend = 1;}
   else if((macdMain<macdSignal && macdMainPrev>=macdSignalPrev && macdMain>0 && macdMainPrev>0)
   ||(MACD_Main_0<MACD_Main_1 && MACD_Signal_0<MACD_Signal_1 && MACD_Main_0<MACD_Signal_0))
   {MACDTrend = 2;}
  
   if (USE_Last_MACD_Signal==1){
            
            
            if (last_macd3_signal!=MACDTrend&&MACDTrend>0){last_macd3_signal=MACDTrend;return(last_macd3_signal);}
            else return(last_macd3_signal);
            }
   else return(MACDTrend);

      
      
   }  
//==MACD Singal Crossing zero==========================================================
int MACD4()
   {
   int MACDTrend = 0;   //1=Buy , 2= Sell


   if(macdSignal>0 && macdSignalPrev<0)
   {MACDTrend = 1;}
   else if(macdSignal<0 && macdSignalPrev>0)
   {MACDTrend = 2;}
 
  if (USE_Last_MACD_Signal==1){
           
            
            if (last_macd4_signal!=MACDTrend&&MACDTrend>0){last_macd4_signal=MACDTrend;return(last_macd4_signal);}
            else return(last_macd4_signal);
            }
   else return(MACDTrend);

      
   }           
//RSI MODE overbought & oversold==============================================================  
int RSI()
   {   
      int RSITrend = 0;//1 = buy, 2 = sell
      
      if (RSIValue > RSIHigh_Level){RSITrend = 2;}//SELL
      else if (RSIValue < RSILow_Level){RSITrend = 1;}//BUY
      if (USE_Last_RSI_Signal==1){
            
            
            if (last_rsi_signal!=RSITrend&&RSITrend>0){last_rsi_signal=RSITrend;return(last_rsi_signal);}
             else return(last_rsi_signal);
            
            }
      else return(RSITrend);
    }  
//RSI MODE 2 trend=======================================================================    
int RSI2()
   {   
     int RSITrend = 0;//1 = buy, 2 = sell
 
     if ((RSIcurrent > RSIprevious)&&(Open[0]>Open[1])){RSITrend=1;}//BUY
     if ((RSIcurrent< RSIprevious)&&(Open[0]<Open[1])){RSITrend=2;}//SELL
       if (USE_Last_RSI_Signal==1){
            
            
            if (last_rsi2_signal!=RSITrend&&RSITrend>0){last_rsi2_signal=RSITrend;return(last_rsi2_signal);}
             else return(last_rsi2_signal);
            }
     else return(RSITrend);
     
   }  
//RSI MODE 2 trend=======================================================================    
int RSI3()
   {   
     int RSITrend = 0;//1 = buy, 2 = sell
 
     if (RSI2()==1||RSI()==1){RSITrend=1;}//BUY
     if (RSI2()==2||RSI()==2){RSITrend=2;}//SELL
       if (USE_Last_RSI_Signal==1){
           
            
            if (last_rsi3_signal!=RSITrend&&RSITrend>0){last_rsi3_signal=RSITrend;return(last_rsi3_signal);}
            else return(last_rsi3_signal);
            }
    else  return(RSITrend);
     
   } 
//====================================================================================     
//RSI Mode 4=======================================================================    
int RSI4()

   {   
     int RSITrend = 0;//1 = buy, 2 = sell
 
    if ((RSIcurrent>=RSIBuyZone)&&(RSIcurrent<=RSIHigh_Level)){RSITrend=1;}//BUY
     if ((RSIcurrent<=RSISellZone)&&(RSIcurrent>=RSILow_Level)){RSITrend=2;}//SELL
       if (USE_Last_RSI_Signal==1){
           
            
            if (last_rsi4_signal!=RSITrend&&RSITrend>0){last_rsi4_signal=RSITrend;return(last_rsi4_signal);}
            else return(last_rsi4_signal);
            }
    else  return(RSITrend);
     
   }   
   
//SAR ===================================================================================
int SAR()
   {  
  
      int SARTrend = 0;   //1 = buy, 2 = sell
      if (SARSignal<Close[1]){SARTrend = 1;}
      else{SARTrend = 2;}
        
         if (USE_Last_SAR_Signal==1){
            
            
            if (last_sar_signal!=SARTrend&&SARTrend>0){last_sar_signal=SARTrend;return(last_sar_signal);}
             else return(last_sar_signal);
            }
     
     else return (SARTrend); 
   }     
 
   
//STOCHASTIC=======================================================================================
int STO()
   {    
     int STOTrend = 0; //1 = buy, 2 = sell
      double curr,prev;
   curr=STOValue - STOSignal;
  prev=STOValuepre - STOSignalpre;      
    
      if (useSTOHighLow == 1)
      {
         if ((curr*prev<=0)&&(curr<0)&& STOValue > STOHigh){STOTrend = 2;}
         if ((curr*prev<=0)&&(curr>0) && STOValue < STOLow){STOTrend = 1;}
         
      }
      else
      {
         if (STOValue > STOSignal||(curr*prev<=0)&&(curr>0)){STOTrend = 1;}
         else if (STOValue < STOSignal||(curr*prev<=0)&&(curr<0)) {STOTrend = 2;}
         
      }
       if (USE_Last_STO_Signal==1){
            
            
            if (last_sto_signal!=STOTrend&&STOTrend>0){last_sto_signal=STOTrend;return(last_sto_signal);}
              else return(last_sto_signal);
            }
   else return(STOTrend);   
}    


//CALCULATE SIGNALS=======================================================================================
int Signal()
  {
   int Trend=0; //1 = buy, 2 = sell
   int s=0;
   int select[7];
   int sig[7];
   select[0]=USE_RSI;
   select[1]=USE_STO;
   select[2]=USE_SAR;
   select[3]=USE_MA;
   select[4]=USE_MACD;
   select[5]=USE_ZZAG;
   select[6]=USE_3StepMA; 
    
notused=0;
uptrend=0;
downtrend=0;
countoption=0;  
   
   
for(int i=0;i<7;i++)
{
if (select[i]==1)
   {
      if (i==0){
                   switch(RSI_MODE)
                     {
                     case 1: sig[0]=RSI();                               
                     case 2: sig[0]=RSI2();                        
                     case 3: sig[0]=RSI3();
                     case 4: sig[0]=RSI4();                        
                     }
               }
            
     
      if (i==1){sig[1]=STO();}
      if (i==2){sig[2]=SAR();}
      if (i==3)   {
      
      switch(MA_MODE)
                     {
                     case 1: sig[3]=MA();                               
                     case 2: sig[3]=MA2();                                                     
                     case 3: sig[3]=MA3(); 
                     case 4: sig[3]=MA4();                                                     
                     case 5: sig[3]=MA5();                          
                     }
      
      
      
                  }
      
      
      
      
      
      if (i==4)
                     {
                     switch(MACD_MODE)
                     {
                     case 1: sig[4]=MACD();                               
                     case 2: sig[4]=MACD2();                        
                     case 3: sig[4]=MACD3();   
                     case 4: sig[4]=MACD4();                   
                     }
                     }
      if (i==5) sig[5]=ZZAG();     
       if (i==6)
                     {
                     switch(StepMA_MODE)
                     {
                     case 1: sig[6]=stepmacross();                               
                     case 2: sig[6]=stepmatouch();                        
                     case 3: sig[6]=stepmacrosstouch();   
                                    
                     }
                     }              
      s++;}
}
   
   

     

   //CHECK FOR SELECTED MODES SIGNALS
 for(i=0;i<7;i++) 
 {
     // if (i==2) break;
      if (sig[i]==2){downtrend++;} 
      
      if (sig[i]==1){uptrend++;} 
    //  if (modes[i]==0)notused++;
      
    
 }//for(o=0;o<5;o++) 
 

if (uptrend==SelectedCount()&&SelectedCount()>0)Trend=1;
if (downtrend==SelectedCount()&&SelectedCount()>0 ) Trend=2;


   



return(Trend);
 } 
 //==========================================================================
 //CALCULATE CLOSING SIGNALS=======================================================================================
int CloseSignal()
  {
   int Trend; //1 = buy, 2 = sell
   int s=0;
   int select[5];
   int sig[5];
   select[0]=USE_RSI_CLOSING;
   select[1]=USE_STO_CLOSING;
   select[2]=USE_SAR_CLOSING;
   select[3]=USE_MA_CLOSING;
   select[4]=USE_MACD_CLOSING;

    
notused=0;
uptrend=0;
downtrend=0;
countoption=0;  
   
   
for(int i=0;i<5;i++)
{
if (select[i]==1)
   {
      if (i==0){
                   switch(RSI_MODE_CLOSING)
                     {
                     case 1: sig[0]=CRSI();                               
                     case 2: sig[0]=CRSI2();                        
                     case 3: sig[0]=CRSI3();
                     case 4: sig[0]=CRSI4();                        
                     }
               }
            
     
      if (i==1){sig[1]=CSTO();}
      if (i==2){sig[2]=CSAR();}
      if (i==3)   {
      
      switch(MA_MODE_CLOSING)
                     {
                     case 1: sig[3]=CMA();                               
                     case 2: sig[3]=CMA2();                        
                     case 3: sig[3]=CMA3();   
                     case 4: sig[3]=CMA4();                                                     
                     case 5: sig[3]=CMA5();                         
                     }
      
      
      
                  }
      
      
      
      
      
      if (i==4)
                     {
                     switch(MACD_MODE_CLOSING)
                     {
                     case 1: sig[4]=CMACD();                               
                     case 2: sig[4]=CMACD2();                        
                     case 3: sig[4]=CMACD3(); 
                     case 4: sig[4]=CMACD4();                        
                     }
                     }
                 
                    
      s++;}
}
   
   

     

   //CHECK FOR SELECTED MODES SIGNALS
 for(i=0;i<5;i++) 
 {
     // if (i==2) break;
      if (sig[i]==2){downtrend++;} 
      
      if (sig[i]==1){uptrend++;} 
    //  if (modes[i]==0)notused++;
      
    
 }//for(o=0;o<5;o++) 
 

if (uptrend==closeSelectedCount()&&closeSelectedCount()>0)Trend=1;
if (downtrend==closeSelectedCount()&&closeSelectedCount()>0 ) Trend=2;
  
  

   



return(Trend);
 } 
 //==========================================================================
int SelectedCount()
{
int s=0;
int select[7];
select[0]=USE_RSI;
select[1]=USE_STO;
select[2]=USE_SAR;
select[3]=USE_MA;
select[4]=USE_MACD;
select[5]=USE_ZZAG;
select[6]=USE_3StepMA; 
for(int i=0;i<7;i++)
{
if (select[i]==1){s++;}
}
return(s);
}

int closeSelectedCount()
{
int s=0;
int select[5];
select[0]=USE_RSI_CLOSING;
   select[1]=USE_STO_CLOSING;
   select[2]=USE_SAR_CLOSING;
   select[3]=USE_MA_CLOSING;
   select[4]=USE_MACD_CLOSING;

for(int i=0;i<5;i++)
{
if (select[i]==1){s++;}
}
return(s);
}
//===========================================================================

void display()
   {
   
      if (IsTesting()==false &&IsOptimization()==false){

        if (canbuy) clabel("mainsignal",500,20,"Main Signal : Up-Buy",Blue);
            else if (cansell)clabel("mainsignal",500,20,"Main Signal: Down-Sell",Red);
            else clabel("mainsignal",500,20,"Main Signal:Please Wait For Right Signal",White);
            
         if (CloseSignal()==1) clabel("closesignal",500,30,"Closing Signal : You Can Close Sell Positions",Blue);
            else if (CloseSignal()==2)clabel("closesignal",500,30,"Closing Signal: You Can Close Buy Positions",Red);
            else clabel("closesignal",500,30,"Closing Signal:Please Wait For Right Signal",White);
            
         if (MA()==1)clabel("masignal",500,40,"Moving Average Mode 1 Signal : Up-Buy",Blue);
            else if (MA()==2)clabel("masignal",500,40,"Moving Average Mode 1 Signal :Down-Sell",Red);
            else clabel("masignal",500,40,"Moving Average Mode 1 Signal :Please Wait For Right Signal",White);
            
       if (MA2()==1)clabel("ma2signal",500,50,"Moving Average Mode 2 Signal : Up-Buy",Blue);
            else if (MA2()==2)clabel("ma2signal",500,50,"Moving Average Mode 2 Signal :Down-Sell",Red);
            else clabel("ma2signal",500,50,"Moving Average Mode 2 Signal :Please Wait For Right Signal",White);
            
       if (MA3()==1)clabel("ma3signal",500,60,"Moving Average Mode 3 Signal : Up-Buy",Blue);
            else if (MA3()==2)clabel("ma3signal",500,60,"Moving Average Mode 3 Signal :Down-Sell",Red);
            else clabel("ma3signal",500,60,"Moving Average Mode 3 Signal :Please Wait For Right Signal",White);
       
       if (MA4()==1)clabel("ma4signal",500,70,"Moving Average Mode 4 Signal : Up-Buy",Blue);
            else if (MA3()==2)clabel("ma4signal",500,70,"Moving Average Mode 4 Signal :Down-Sell",Red);
            else clabel("ma4signal",500,70,"Moving Average Mode 4 Signal :Please Wait For Right Signal",White);
       
       if (MA5()==1)clabel("ma5signal",500,80,"Moving Average Mode 5 Signal : Up-Buy",Blue);
            else if (MA3()==2)clabel("ma5signal",500,80,"Moving Average Mode 5 Signal :Down-Sell",Red);
            else clabel("ma5signal",500,80,"Moving Average Mode 5 Signal :Please Wait For Right Signal",White);
       
       
      

           if (MACD()==1)clabel("macdsignal",500,90,"MACD Mode 1 Signal : Up-Buy",Blue);
            else if (MACD()==2)clabel("macdsignal",500,90,"MACD Mode 1 Signal : Down-Sell",Red);
             else if (MACD()==3)clabel("macdsignal",500,90,"MACD Mode 1 Signal : Up->Down",Red);
              else if (MACD()==4)clabel("macdsignal",500,90,"MACD Mode 1 Signal : Down->Up",Red);
            else  clabel("macdsignal",500,90,"MACD Mode 1 Signal :Please Wait For Right Signal",White);

         if (MACD2()==1)clabel("macd2signal",500,100,"MACD Mode 2 Signal : Up-Buy",Blue);
            else if (MACD2()==2)clabel("macd2signal",500,100,"MACD Mode 2 Signal : Down-Sell",Red);
            else  clabel("macd2signal",500,100,"MACD Mode 2 Signal :Please Wait For Right Signal",White);

          if (MACD3()==1)clabel("macd3signal",500,110,"MACD Mode 3 Signal : Up-Buy",Blue);
            else if (MACD3()==2)clabel("macd3signal",500,110,"MACD Mode 3 Signal : Down-Sell",Red);
            else  clabel("macd3signal",500,110,"MACD Mode 3 Signal :Please Wait For Right Signal",White);
         
         if (MACD4()==1)clabel("macd4signal",500,120,"MACD Mode 4 Signal : Up-Buy",Blue);
            else if (MACD4()==2)clabel("macd4signal",500,120,"MACD Mode 4 Signal : Down-Sell",Red);
            else  clabel("macd4signal",500,120,"MACD Mode 4 Signal :Please Wait For Right Signal",White);


         if (RSI()==1)clabel("rsisignal",500,130,"RSI Mode 1 Signal : Up-Buy",Blue);
            else if (RSI()==2)clabel("rsisignal",500,130,"RSI Mode 1 Signal : Down-Sell",Red);
            else clabel("rsisignal",500,130,"RSI Mode 1 Signal :Please Wait For Right Signal",White);
         
          if (RSI2()==1)clabel("rsisignal2",500,140,"RSI Mode 2 Signal : Up-Buy",Blue);
            else if (RSI2()==2)clabel("rsisignal2",500,140,"RSI Mode 2 Signal : Down-Sell",Red);
            else clabel("rsisignal2",500,140,"RSI Mode 2 Signal :Please Wait For Right Signal",White);
          
          if (RSI3()==1)clabel("rsisignal3",500,150,"RSI Mode 3 Signal : Up-Buy",Blue);
            else if (RSI2()==2)clabel("rsisignal3",500,150,"RSI Mode 3 Signal : Down-Sell",Red);
            else clabel("rsisignal3",500,150,"RSI Mode 3 Signal :Please Wait For Right Signal",White);
           
          if (RSI4()==1)clabel("rsisignal4",500,160,"RSI Mode 4 Signal : Up-Buy",Blue);
            else if (RSI2()==2)clabel("rsisignal4",500,160,"RSI Mode 4 Signal : Down-Sell",Red);
            else clabel("rsisignal4",500,160,"RSI Mode 4 Signal :Please Wait For Right Signal",White);
          
           
         
            
            
         if (STO()==1)clabel("stosignal",500,170,"STO Signal : Up-Buy",Blue);
         else if (STO()==2)clabel("stosignal",500,170,"STO Signal : Down-Sell",Red);
         else clabel("stosignal",500,170,"STO Signal :Please Wait For Right Signal",White);
         if (SAR()==1)clabel("sarsignal",500,180,"SAR Signal : Up-Buy",Blue);
         else if (SAR()==2)clabel("sarsignal",500,180,"SAR Signal : Down-Sell",Red);
         else clabel("sarsignal",500,180,"SAR Signal :Please Wait For Right Signal",White);
        
      
         if (trend_detect()==1)clabel("trend",500,190,"Trend : Bullish",Blue);
         else if (trend_detect()==2)clabel("trend",500,190,"Trend: Bearish",Red);
         else if (trend_detect()==4)clabel("trend",500,190,"Trend : Range->Bullish",DodgerBlue);
         else if (trend_detect()==3)clabel("trend",500,190,"Trend: Range->Bearish",Maroon);
      if (signalTRIX()==1)clabel("noise",500,200,"Noise : Don\'t Trade, Trend Looks Like a Bad Range",Red);
     if (signalTRIX()==0)clabel("noise",500,200,"Noise : You Can Trade Now ",Green);

 Comment("\n\n FSF Semi Combo Trader (BETA)\n",
            "Copyright  2010,Farshad Saremifar , Farshad.Saremifar@gmail.com\n",
            "Forex Account Server:",AccountServer(),"\n",
            "Account Balance:  $",AccountBalance(),"\n",
            "Lots:  ",DoubleToStr(LOT,3),"\n",
            "Symbol: ", Symbol(),"\n",
            "Pip Spread:  ",MarketInfo(Symbol(),MODE_SPREAD),"\n",
            " Server Time: ",HourMQL4(),":",Minute(),":",Seconds(),"\n",
            "Minimum Lot Size: ",MarketInfo(Symbol(),MODE_MINLOT),"\n",
            "Account Leverage: ",AccountLeverage(),"\n",
       
            "You Have Choosed: ",SelectedCount()," Option(s)","\n",
            "If You make too much money with this EA - some gift or donations accepted [:-)");
     
      }
      
    
      
      
}  
///-------------------------------------------------------------------------

void clabel(string lblname,int x,int y,
string txt,color txtcolor){
 if (ObjectFind( lblname)>0) ObjectDelete(lblname);
ObjectCreate(lblname, OBJ_LABEL,0, 0, 0);
ObjectSet(lblname, OBJPROP_CORNER, 0);
ObjectSetText(lblname,txt,7,"Verdana", txtcolor);
ObjectSet(lblname, OBJPROP_XDISTANCE, x);
ObjectSet(lblname, OBJPROP_YDISTANCE, y);


}

int trend_detect(){

// double curr;

//curr=mediumStepnow      - slowerStepnow;


if (Trend_Mode==1){
if (adxSignal(ADX_PERIOD,ADX_MAINLEVEL,0,ADX_TIMEFRAME)==0)return(3);//range-down
if (adxSignal(ADX_PERIOD,ADX_MAINLEVEL,0,ADX_TIMEFRAME)==1)return(4);//range-up
if (adxSignal(ADX_PERIOD,ADX_MAINLEVEL,0,ADX_TIMEFRAME)==2)return(1);//up
if (adxSignal(ADX_PERIOD,ADX_MAINLEVEL,0,ADX_TIMEFRAME)==3)return(2);//down
}
if (Trend_Mode==2)
{
if (mediumStepnow>slowerStepnow||fasterStepnow>slowerStepnow) return(1);
if (mediumStepnow<slowerStepnow||fasterStepnow<slowerStepnow) return(2);
}

else return(0);


}


int adxSignal(int adx_Period, int adx_Main_Level,int shift,int timeframe)
{
   double adxMain = iADX(NULL,timeframe,adx_Period,PRICE_CLOSE,MODE_MAIN,shift);
   double adxPlus = iADX(NULL,timeframe,adx_Period,PRICE_CLOSE,MODE_PLUSDI,shift);
   double adxMinus = iADX(NULL,timeframe,adx_Period,PRICE_CLOSE,MODE_MINUSDI,shift);
   
   int result;
   
   
   if(adxMain < adxPlus && adxMain < adxMinus)
   {
      
      result = 0;
   }
   else if(adxMain < adx_Main_Level)
   {
      
      result = 1;
   }
   else 
   {
      if(adxPlus > adxMinus)
      {
        
         result = 2;
      }
      else if(adxPlus < adxMinus)
      {
         
         result = 3;
      }
   }
   

 return(result);  
}  
int signalTRIX()
{
int signal=0;



if ((value1>value3))signal=1;       
else signal=0;
return(signal);


}
// ------
int Save_Profit(){
if (AccountProfit()>= Profit_to_Close)
   {
    for(int i=OrdersTotal()-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       int type   = OrderType();
               
       bool result = false;
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,Pink);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,Pink);
                          
          }
          
       if(result == false)
          {
            Sleep(3000);
          }
      else if (Cancel_Trading_On_Profit==1) cantrade=false;     
       }
      Print ("Account Profit Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   


return(0);

}
bool checkcanTrading()
{
int    orders=HistoryTotal(); 
if (cantrade==false)
      {
         
            for(int i=orders-1;i>=0;i--)
                  {
                      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
                      if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber) continue;
                      if(TimeDay(OrderCloseTime())!=TimeDay(TimeCurrent())) {cantrade=true; break;}
                      else {cantrade=false; break;}
                  }    
           
      
      
      }
      
 return(cantrade);     

}
int Save_Loss(){
if (AccountProfit()<0-Loss_to_Close)
   {
    for(int i=OrdersTotal()-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       int type   = OrderType();
               
       bool result = false;
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,Pink);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,Pink);
                          
          }
          
       if(result == false)
          {
            Sleep(3000);
          }
      else if (Cancel_Trading_On_Loss==1) cantrade=false;     
       }
      Print ("Account Loss Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   


return(0);

}

int bband(){
datetime Bar,sBar;int buy,sell,i,a,b,nbb3ok,vbb3ok,nbar;double Sstoploss,stoploss,setup2,okbuy,oksell;

buy=0;sell=0;

   double vbb1 =iBands(NULL,BBAND_TIMEFRAME,BB1_Period,1,0,PRICE_CLOSE,MODE_UPPER,1);
   double vbb2 =iBands(NULL,BBAND_TIMEFRAME,BB2_Period,2,0,PRICE_CLOSE,MODE_UPPER,1);
   double vbb3 =iBands(NULL,BBAND_TIMEFRAME,BB3_Period,3,0,PRICE_CLOSE,MODE_UPPER,1);
   double nbb1 =iBands(NULL,BBAND_TIMEFRAME,BB1_Period,1,0,PRICE_CLOSE,MODE_LOWER,1);
   double nbb2 =iBands(NULL,BBAND_TIMEFRAME,BB2_Period,2,0,PRICE_CLOSE,MODE_LOWER,1);
   double nbb3 =iBands(NULL,BBAND_TIMEFRAME,BB3_Period,3,0,PRICE_CLOSE,MODE_LOWER,1);
  
  
  if(Low[1]<=nbb3 )
  { okbuy=0;  Bar=Time[1];
  
      for( i=Range_Parameter;i>0;i--)
      {
      double rsi=iRSI(NULL,RSI_TIMEFRAME,RSIperiod,PRICE_CLOSE,i);
      if(rsi<30){nbb3ok=1;}
      }
  }
  
 
  if(okbuy==0 && nbb3ok==1 && Close[1]>nbb2 && buy==0)
  {okbuy=1;nbb3ok=0;a=0;
  // stoplossbb=Low[iLowest(NULL,0,MODE_LOW,iBarShift(NULL,0,Bar,FALSE),1)]-Step_For_Loss*Point();
//   stoplossbbuy=Low[iLowest(NULL,0,MODE_HIGH,Step_For_Loss,1)];
   return(1);
  
  }
  

  
  /**********************************************sell**********************************************************/
  
    if(High[1]>=vbb3 )
  { oksell=0;  sBar=Time[1];
  
      for( i=Range_Parameter;i>0;i--)
      {
      rsi=iRSI(NULL,0,RSIperiod,PRICE_CLOSE,i);
      if(rsi>70){vbb3ok=1;}
      }
  }
 
  if(oksell==0 && vbb3ok==1 && Close[1]<vbb2 && sell==0)
  {oksell=1;vbb3ok=0;b=0;
  //stoplossbb=High[iHighest(NULL,0,MODE_HIGH,iBarShift(NULL,0,sBar,FALSE),1)]+Step_For_Loss*Point();
  //stoplossbsell=High[iHighest(NULL,0,MODE_HIGH,Step_For_Loss,1)];
   return(2);
  }
  
 
 
}




//+----
int gettimeframe(ENUM_TIMEFRAMES time){

switch(time)
                     {
                     case 1: return(PERIOD_M1);                               
                     case 2: return(PERIOD_M5);                   
                     case 3: return(PERIOD_M15);                               
                     case 4: return(PERIOD_M30);                   
                     case 5: return(PERIOD_H1);                               
                     case 6: return(PERIOD_H4);
                     case 7: return(PERIOD_D1);                   
                     }

}


//MA Cross======================================================================================
int CMA()
   {
   int PosOpen=0;      
   double curr,prev;
   curr=CFastMaCurrent - CMidMaCurrent;
  prev=CFastMaPrevious - CMidMaPrevious;   
                             
   if((curr*prev<=0)&&(curr>0)) 
              
      {
      PosOpen=1;
      }  
   if((curr*prev<=0)&&(curr<0)) 
                      
      {
      PosOpen=2;
      }             
    
   return(PosOpen);                                         
   }   
   
//MA2 Cross======================================================================================
int CMA2()
   {
   double curr,prev;
   curr=CMidMaCurrent - CSlowMaCurrent;
  prev=CMidMaPrevious - CSlowMaPrevious;   
   int PosOpen=0; 
   if((curr*prev<=0)&&(curr>0)) 
                                                   
      {
      PosOpen=1;
      } 
   if((curr*prev<=0)&&(curr<0)) 
                      
      {
      PosOpen=2;
      }             
    
   return(PosOpen);                                         
   }   
   
//MA3 Cross======================================================================================
int CMA3()
   {
   
   int PosOpen=0;                                                 
   if (CMA2()==1||CMA()==1)    //buy signal
      {
      PosOpen=1;
      }                  
   if (CMA2()==2||CMA()==2) // sell signall
      {
      PosOpen=2;
      }             
    
   return(PosOpen);                                         
   }   
      
   
//MA4 Cross======================================================================================
int CMA4()
   {
   double curr,prev;
   curr=CFastMaCurrent - CSlowMaCurrent;
  prev=CFastMaPrevious - CSlowMaPrevious; 
   int PosOpen=0; 
   if((curr*prev<=0)&&(curr>0)) 
                                                   
      {
      PosOpen=1;
      } 
   if((curr*prev<=0)&&(curr<0)) 
                      
       {
      PosOpen=2;
      }             
    
   return(PosOpen);                                         
   }   
//MA5 Cross======================================================================================
int CMA5()
   {
   
   int PosOpen=0;                                                 
   if (CMA3()==1||CMA4()==1)    //buy signal
      {
      PosOpen=1;
      }                  
   if (CMA3()==2||CMA4()==2) // sell signall
      {
      PosOpen=2;
      }             
    
   return(PosOpen);                                         
   }   
      
   
//MA4 Cross======================================================================================   
//Signals============================================================================================



//============================================================================================
//MACD TREND METHOD============================================================
int CMACD()
   {
  int CMACDTrend=0;
   
   
   
   if(CMACD_Main_0>CMACD_Main_1 && CMACD_Signal_0>CMACD_Signal_1 && CMACD_Main_0>CMACD_Signal_0) {CMACDTrend = 1;}    //buy
   if(CMACD_Main_0<CMACD_Main_1 && CMACD_Signal_0<CMACD_Signal_1 && CMACD_Main_0<CMACD_Signal_0) {CMACDTrend = 2;}    // sell
   if(CMACD_Main_0<CMACD_Main_1 && CMACD_Signal_0>CMACD_Signal_1 && CMACD_Main_0>CMACD_Signal_0) {CMACDTrend = 3;}    // up-down
   if(CMACD_Main_0>CMACD_Main_1 && CMACD_Signal_0<CMACD_Signal_1 && CMACD_Main_0<CMACD_Signal_0) {CMACDTrend = 4;}    // down-up
   return(CMACDTrend);
   }
//==CMACD MODE 2=============================================================
int CMACD2()
   {
   int CMACDTrend = 0;   //1=Buy , 2= Sell


   if(CmacdMain>CmacdSignal && CmacdMainPrev<=CmacdSignalPrev && CmacdMain<0 && CmacdMainPrev<0){CMACDTrend = 1;}
   else if(CmacdMain<CmacdSignal && CmacdMainPrev>=CmacdSignalPrev && CmacdMain>0 && CmacdMainPrev>0){CMACDTrend = 2;}
   else { CMACDTrend=0;}
   return(CMACDTrend);

      
   }   
//==MACD Both=============================================================
int CMACD3()
   {
   int CMACDTrend = 0;   //1=Buy , 2= Sell


   if((CmacdMain>CmacdSignal && CmacdMainPrev<=CmacdSignalPrev && CmacdMain<0 && CmacdMainPrev<0)
   ||(CMACD_Main_0>CMACD_Main_1 && CMACD_Signal_0>CMACD_Signal_1 && CMACD_Main_0>CMACD_Signal_0))
   {CMACDTrend = 1;}
   else if((CmacdMain<CmacdSignal && CmacdMainPrev>=CmacdSignalPrev && CmacdMain>0 && CmacdMainPrev>0)
   ||(CMACD_Main_0<CMACD_Main_1 && CMACD_Signal_0<CMACD_Signal_1 && CMACD_Main_0<CMACD_Signal_0))
   {CMACDTrend = 2;}
   else { CMACDTrend=0;}
   return(CMACDTrend);

      
      
   }  
//==CMACD Singal Crossing zero==========================================================
int CMACD4()
   {
  int CMACDTrend = 0;   //1=Buy , 2= Sell


   if(CmacdSignal>0 && CmacdSignalPrev<0)
   {CMACDTrend = 1;}
   else if(CmacdSignal<0 && CmacdSignalPrev>0)
   {CMACDTrend = 2;}
  else { CMACDTrend=0;}
   return(CMACDTrend);

      
   }           
//RSI MODE overbought & oversold==============================================================  
int CRSI()
   {   
      int RSITrend = 0;//1 = buy, 2 = sell
      
      if (CRSIValue > RSIHigh_Level){RSITrend = 2;}//SELL
      else if (CRSIValue < RSILow_Level){RSITrend = 1;}//BUY
      
      return(RSITrend);
    }  
//RSI MODE 2 trend=======================================================================    
int CRSI2()
   {   
     int RSITrend = 0;//1 = buy, 2 = sell
 
     if ((CRSIcurrent > CRSIprevious)&&(Open[0]>Open[1])){RSITrend=1;}//BUY
     if ((CRSIcurrent< CRSIprevious)&&(Open[0]<Open[1])){RSITrend=2;}//SELL
   
     return(RSITrend);
     
   }  
//RSI MODE 2 trend=======================================================================    
int CRSI3()
   {   
     int RSITrend = 0;//1 = buy, 2 = sell
 
     if (CRSI2()==1||CRSI()==1){RSITrend=1;}//BUY
     if (CRSI2()==2||CRSI()==2){RSITrend=2;}//SELL
   
     return(RSITrend);
     
   } 
//====================================================================================     
//RSI Mode 4=======================================================================    
int CRSI4()

   {   
     int RSITrend = 0;//1 = buy, 2 = sell
  if ((CRSIcurrent>=RSIBuyZone)&&(CRSIcurrent<=RSIHigh_Level)){RSITrend=1;}//BUY
     if ((CRSIcurrent<=RSISellZone)&&(CRSIcurrent>=RSILow_Level)){RSITrend=2;}//SELL
     
    
     return(RSITrend);
     
   }   
   
//SAR ===================================================================================
int CSAR()
   {  
  
      int SARTrend = 0;   //1 = buy, 2 = sell
      if (CSARSignal<Close[1]){SARTrend = 1;}
      else{SARTrend = 2;}
     
     
     return (SARTrend); 
   }     
 
   
//STOCHASTIC=======================================================================================
int CSTO()
   {    
     int STOTrend = 0; //1 = buy, 2 = sell
       double curr,prev;
   curr=CSTOValue - CSTOSignal;
  prev=CSTOValuepre - CSTOSignalpre;      
    
      if (useSTOHighLow == 1)
      {
         if ((curr*prev<=0)&&(curr<0)&& CSTOValue > STOHigh){STOTrend = 2;}
         if ((curr*prev<=0)&&(curr>0) && CSTOValue < STOLow){STOTrend = 1;}
         
      }
      else
      {
         if (CSTOValue > CSTOSignal||(curr*prev<=0)&&(curr>0)){STOTrend = 1;}
         else if (CSTOValue < CSTOSignal||(curr*prev<=0)&&(curr<0)) {STOTrend = 2;}
         
      }
   return(STOTrend);   
}    

void Martingale()
{
double MinLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2);
   double MaxLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MAXLOT)),2);
   double LotSizeValue = NormalizeDouble((MarketInfo(Symbol(), MODE_LOTSIZE)),0);
   double PipValue=MarketInfo(Symbol(),16);

   if(Money_management==1)
   {
      switch(AccountType)
      {
         case 0: lotsi=NormalizeDouble(MathCeil((risk*AccountEquity())/10000)/10,1); break;
         case 1: lotsi=NormalizeDouble((risk*AccountEquity())/100000,2); break;
         case 2: lotsi=NormalizeDouble((risk*AccountEquity())/1000,2); break;
         default: lotsi=NormalizeDouble(MathCeil((risk*AccountEquity())/10000)/10,1); break;
      }
   }
   else
   {
      lotsi=Lots;
   }
   
   if(lotsi<MinLots){lotsi=MinLots;}
   if(lotsi>MaxLots){lotsi=MaxLots;}
   
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			return(0);
		 }
	  }
   }

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=false;
   } else {
	  ContinueOpening=true;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }

   if (OpenOrders<1) 
   {
     if (UseTimeFilter==1)
     {//check trading time
        if (HourMQL4()>StopTrade && HourMQL4()<StartTrade) 
        {return(0);}//End of trading time check
     }

	    if(canbuy==true&&cansell==false)myOrderType=1;     
	    /// myOrderType=Signal();
       else if(canbuy==false&&cansell==true)    myOrderType=2;  
      // else myOrderType=3;
       //if (CloseSignal()>0)myOrderType=3;
     	  if (ReverseSignal==1)
	     {
	  	     if (myOrderType==1) { myOrderType=2; }
		    else { if (myOrderType==2) { myOrderType=1; } }
	     }
   }

   // if we have opened positions we take care of them
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop*Point()+Pips*Point()))  
				  {						
					 if (OrderStopLoss()>(Ask+Point()*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point()*TrailingStop,OrderClosePrice()-TakeProfit*Point()-TrailingStop*Point(),800,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop*Point()+Pips*Point()))  
				{
					if (OrderStopLoss()<(Bid-Point()*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point()*TrailingStop,OrderClosePrice()+TakeProfit*Point()+TrailingStop*Point(),800,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
							
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point(); }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point(); }
			}
			if (LastType==OP_SELL) 
			{
				
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point(); }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point(); }
			}
		
	  }
   }
	
	Profit=Profit*PipValue;

   if (OpenOrders>=OrderstoProtect)
   {	    
	    
	     if ((Profit>=(AccountBalance()*(risk/100) && Money_management)) || (Profit>=(lotsi*(LotSizeValue/100)) && !Money_management))
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
	        ContinueOpening=false;
	        return(0);
	     }
   }

   

      if (myOrderType==1 && ContinueOpening) 
      {	
	     if ((Bid-LastPrice)>=Pips*Point() || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point(); }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*Point() + (MaxTrades-OpenOrders)*Pips*Point(), Digits());  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"10p3-Sell",Magic,0,Red);		    		    
		    return(0);
	     }
      }
      
      if (myOrderType==2 && ContinueOpening) 
      {
	     if ((LastPrice-Ask)>=Pips*Point() || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point(); }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*Point() - (MaxTrades-OpenOrders)*Pips*Point(), Digits()); }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"10p3-Buy",Magic,0,Blue);		    
		    return(0);
	     }
      }


}

int ZZAG()
{
int signal=0;


 if(zzagbuy!=0){signal=1;}
 if(zzagsell!=0){signal=2;}
 
 if (USE_LAST_ZZAG_SIGNAL==1){
            
            
            if (last_zzag1_signal!=signal&&signal>0){last_zzag1_signal=signal;return(last_zzag1_signal);}
              else return(last_zzag1_signal);
            }
   else return(signal);  
    

}
int CZZAG()
{
int signal=0;


 if(zzagclose!=0){signal=1;}


return(signal);  
    

}


void OpenPosition(string sy, int op, double ll, double Sl=0, double Tp=0, int mn=0, string   lsComm="FSF MultiStrategy") {
  
  color    clOpen;
  datetime ot;
  double   pp, pa, pb, sl, tp;
  int      dg, err, it, ticket=0;

  //if(Autolot){ll=GetOrderLot();}
  
  /*if (op<1){
   if (Sl>0) sl=MarketInfo(Symbol(),MODE_ASK)-Sl*Point(); else sl=0;
   if (Tp>0) tp=MarketInfo(Symbol(),MODE_ASK)+Tp*Point(); else tp=0;
  }else{
   if (Sl>0) sl=MarketInfo(Symbol(),MODE_BID)+Sl*Point(); else sl=0;
   if (Tp>0) tp=MarketInfo(Symbol(),MODE_BID)-Tp*Point(); else tp=0;
   } */  
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=Blue; else clOpen=Red;
  for (it=1; it<=3; it++) {
    if (!IsTesting() && IsStopped()) {
      
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, 4, 0, 0, lsComm, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, 4, Sl, Tp, lsComm, mn, 0, clOpen);
    if (ticket>0) { break;
      
    } else {
      err=GetLastError();
    
      
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=true; break;
      }
      
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(true);
            }
          }
        }
      }
    }
  }
  return(false);
}
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=Red;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=3; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
     // fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      
      fm=OrderModify(OrderTicket(), pp, sl+sl*0.85, tp, ex, cl);
      
      if (fm) {
         break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        
       
        Sleep(1000*10);
      }
    }
  }
  }
  
int stepmacross()
{
double curr;
double prev;
int signal=0;
curr=mediumStepnow      - slowerStepnow;
prev=mediumStepprevious - slowerStepprevious;

if (curr*prev<=0&&curr>0)signal=1; //buy
else if (curr*prev<=0&&curr<0)signal=2;//sell
if (USE_Last_3StepMA_Signal==1){
          if (last_step_signal!=signal&&signal>0){last_step_signal=signal;return(last_step_signal);}
              else return(last_step_signal);
            }
else return(signal);  

}
int stepmatouch()
{
int signal=0;
 double curr;
double prev;
curr=mediumStepnow      - slowerStepnow;
prev=mediumStepprevious - slowerStepprevious;
if ((curr>0)&&((Ask==mediumStepnow+MarketInfo(Symbol(),MODE_SPREAD)*Point()*MyPoint)||(Ask==slowerStepnow+MarketInfo(Symbol(),MODE_SPREAD)*Point()*MyPoint)))signal=1;//buy
if ((curr<0)&&((Bid==mediumStepnow-MarketInfo(Symbol(),MODE_SPREAD)*Point()*MyPoint)||(Bid==slowerStepnow-MarketInfo(Symbol(),MODE_SPREAD)*Point()*MyPoint)))signal=2;//sell
if (USE_Last_3StepMA_Touch_Signal==1)

{
          if (last_step_touch_signal!=signal&&signal>0){last_step_touch_signal=signal;return(last_step_touch_signal);}
              else return(last_step_touch_signal);
            }
else return(signal); 

}
int stepmacrosstouch()
{

if (stepmacross()==1||stepmatouch()==1)return(1);
if (stepmacross()==2||stepmatouch()==2)return(2);


}  

